//All init data can be added to or edited here if you copy this file outside of BuiltIn and then set that file path (relative path from Moxie.exe) in the Setup table record Cnw.MHtml.Init, or pass as a parameter to [MHtml]

tinymce.init({
	// General options
	selector: ".mceEditor",
	relative_urls : false,
	browser_spellcheck: true,
	contextmenu: false,
	toolbar_mode: 'wrap',
	
	plugins: 'lists advlist anchor autolink autosave charmap code emoticons fullscreen help image insertdatetime link lists media nonbreaking pagebreak searchreplace table template visualblocks visualchars wordcount',
	toolbar: 'styles | bullist numlist indent outdent blockquote | alignleft aligncenter alignright alignjustify | table | charmap emoticons nonbreaking | link image media template | searchreplace removeformat visualblocks visualchars code',
	
	// plugin custom configs
	image_advtab: true,
	link_context_toolbar: false,
	visualchars_default_state: false,
	link_quicklink: false,
	
	//Custom Styles
	style_formats: [
		
	],
	style_formats_merge: true,
	style_formats_autohide: true,
	pagebreak_separator: "<div class='PageBreak' style='page-break-after: always;'>--PageBreak--</div>",
	
	//Custom config options for typical Moxie.Build use case
	allow_conditional_comments: true,
	extended_valid_elements: '\?',
	
	//Custom Templates
	templates: [ 
		{title: 'Responsive Video', description: 'Responsive Video that is always full width of device or the container it is inside of', content: '<div class="RspVideo"><span style="text-align: center;"><iframe src="//www.youtube-nocookie.com/embed/CHANGEME" frameborder="0" allowfullscreen></iframe></span></div>'},
		{title: 'Responsive layout 1-2', description: 'Responsive layout with 1 tall column on the left and 2 rows in the right column', content: '<div class="row"><div class="col-md-6">1</div><div class="col-md-6"><div class="row"><div class="col-md-12">2A</div></div><div class="row"><div class="col-md-12">2B</div></div></div></div>'},
		{title: 'Responsive layout 2-1', description: 'Responsive layout with 2 rows in the left column and 1 tall column on the right', content: '<div class="row"><div class="col-md-6"><div class="row"><div class="col-md-12">1A</div></div><div class="row"><div class="col-md-12">1B</div></div></div><div class="col-md-6">2</div></div>'},
		{title: 'Responsive row 50-50', description: 'Responsive row divided in two cells with ratios of 50%, 50%', content: '<div class="row"><div class="col-md-6">50</div><div class="col-md-6">50</div></div>'},
		{title: 'Responsive row 67-33', description: 'Responsive row divided in two cells with ratios of 67%, 33%', content: '<div class="row"><div class="col-md-8">67</div><div class="col-md-4">33</div></div>'},
		{title: 'Responsive row 33-67', description: 'Responsive row divided in two cells with ratios of 33%, 37%', content: '<div class="row"><div class="col-md-4">33</div><div class="col-md-8">67</div></div>'},
		{title: 'Responsive row 33-33-33', description: 'Responsive row divided in three cells with ratios of 33%, 33%, 33%', content: '<div class="row"><div class="col-md-4">33</div><div class="col-md-4">33</div><div class="col-md-4">33</div></div>'},
		{title: 'Responsive row 50-25-25', description: 'Responsive row divided in three cells with ratios of 50%, 25%, 25%', content: '<div class="row"><div class="col-md-6">50</div><div class="col-md-3">25</div><div class="col-md-3">25</div></div>'},
		{title: 'Responsive row 25-50-25', description: 'Responsive row divided in three cells with ratios of 25%, 50%, 25%', content: '<div class="row"><div class="col-md-3">25</div><div class="col-md-6">50</div><div class="col-md-3">25</div></div>'},
		{title: 'Responsive row 25-25-50', description: 'Responsive row divided in three cells with ratios of 25%, 25%, 50%', content: '<div class="row"><div class="col-md-3">25</div><div class="col-md-3">25</div><div class="col-md-6">50</div></div>'},
		{title: 'Responsive row 25-25-25-25', description: 'Responsive row divided in four cells with ratios of 25% each', content: '<div class="row"><div class="col-md-3">25</div><div class="col-md-3">25</div><div class="col-md-3">25</div><div class="col-md-3">25</div></div>'}
    ],
	
	// Custom handling of Esc to allow user to get out of a div, like the ones from the templates above. Otherwise, they can't click out of if it in many cases
	// Credit: nguyenkiidu re https://github.com/tinymce/tinymce/issues/4416 & https://gist.github.com/nguyenkiidu/c102065f2c475d18521ebf14d168498b
	init_instance_callback: function (editor) {
		editor.on('KeyDown', function (e) {
		  if(e.keyCode == 27) {
			let editor = tinyMCE.activeEditor
			const dom = editor.dom
			const parentBlock = tinyMCE.activeEditor.selection.getSelectedBlocks()[0]
			const containerBlock = parentBlock.parentNode.nodeName == 'BODY' ? dom.getParent(parentBlock, dom.isBlock) : dom.getParent(parentBlock.parentNode, dom.isBlock)
			let newBlock = tinyMCE.activeEditor.dom.create('p')
			newBlock.innerHTML = '<br data-mce-bogus="1">';
			dom.insertAfter(newBlock, containerBlock)
			let rng = dom.createRng();
			newBlock.normalize();
			rng.setStart(newBlock, 0);
			rng.setEnd(newBlock, 0);
			editor.selection.setRng(rng);
		  }
		});
	}
});